module.exports = (grunt) ->
  grunt.initConfig
    coffee:
        options:
          bare: true
          join: true
        compile:
          files:
            'tmp/coffee.js': 'src/coffee/*.coffee'

    concat:
      dist:
        files:
          'index.js': ['src/js/intro.js', 'tmp/coffee.js', 'src/js/outro.js']

    uglify:
      compile:
        files:
          'index.min.js': 'index.js'

    karma:
      options:
        frameworks: ['jasmine']
        runnerPort: 9999,
        singleRun: true,
        browsers: ['PhantomJS']
        files: ['index.js', 'spec/*.coffee']
      dev:
        reporters: 'dots'

  grunt.loadNpmTasks 'grunt-contrib-coffee'
  grunt.loadNpmTasks 'grunt-contrib-concat'
  grunt.loadNpmTasks 'grunt-contrib-uglify'
  grunt.loadNpmTasks 'grunt-karma'

  grunt.registerTask 'clear', 'removes temp directory', () ->
    grunt.file.delete 'tmp/'

  grunt.registerTask 'build', ['coffee', 'concat', 'clear','uglify']
  grunt.registerTask 'test', ['build', 'karma']