router = null

describe 'A BasicRouter', ->
  beforeEach ->
    router = new BasicRouter

  it 'should pass route parameters to the callback', ->
    args = undefined
    router.register 'foo/:bar/:baz?', (a) -> args = a
    routeMatched = router.route 'foo/xxx'

    expect(routeMatched).toBe(true)
    expect(args).toBeDefined()
    expect(args.bar).toBe("xxx")
    expect(args.baz).toBeUndefined()

  it 'should pass additional parameters to the callback', ->
    args = undefined
    additional = undefined
    router.register 'user/:id', (a0, a1) ->
      args = a0
      additional = a1
    routeMatched = router.route 'user/123', 1337

    expect(routeMatched).toBe(true)
    expect(args).toBeDefined()
    expect(args.id).toBe('123')
    expect(additional).toBe(1337)

  it 'should fire the not found handler if no route matches', ->
    called = false
    notFoundHandlerCalled = false
    
    route = null
    firstArg = null
    secondArg = null

    callback = -> notCalled = true

    router.register 'foo/:bar', callback
    router.register 'bar/baz', callback

    router.registerNotFoundHandler (r, f, s) ->
      notFoundHandlerCalled = true
      route = r
      firstArg = f
      secondArg = s

    router.route 'foo', 1, 2

    expect(called).toBe(false)
    expect(notFoundHandlerCalled).toBe(true)
    expect(route).toBe('foo')
    expect(firstArg).toBe(1)
    expect(secondArg).toBe(2)