class Key
  constructor: (@name, @optional = false) ->

class Route
  constructor: (@regexp, @keys) ->

  ###
  Algorithm taken from visionmedia/express/lib/router/route.js (MIT license)
  Copyright (c) 2009-2012 TJ Holowaychuk
  ###
  match: (path) ->
    params = []
    matched = @regexp.exec path

    return false unless matched

    for i in [1...matched.length]
      key = @keys[i - 1]

      val = if typeof matched[i] is 'string'
        decodeURIComponent matched[i]
      else
        matched[i]

      if key
        params[key.name] = val
      else
        params.push val

    params

class RouteParser
  constructor: (@sensitive = false, @strict = false) ->
  parse: (routeString) ->
    arr = []
    regexp = pathRegexp routeString, arr, @sensitive, @strict
    keys = for key in arr
      new Key key.name, key.optional
    new Route regexp, keys
